#pragma once

#include <memory>
#include <string>

#include "Image.h"

class PngWriterImpl;

class PngWriter
{
public:
    PngWriter();

    static std::unique_ptr<PngWriter> Create();

    void SetPath(const std::string& path);

    void Write(const std::unique_ptr<Image<unsigned char> >& image) const;

private:
    std::unique_ptr<PngWriterImpl> mImpl;

};

using PngWriterPtr = std::unique_ptr<PngWriter>;
