#pragma once

#include "Widget.h"
#include "Color.h"

#include <functional>
#include <string>

class PaintEvent;
class MouseEvent;

class Button : public Widget
{
public:
    using clickFunc = std::function<void(Widget* self)>;

    Button();

    static std::unique_ptr<Button> Create();

    void setLabel(const std::string& text);

    void setOnClickFunction(clickFunc func);

protected:
    void onMyMouseEvent(const MouseEvent* event) override;

    void onPaintEvent(const PaintEvent* event) override;

private:
    std::string mLabel;
    clickFunc mClickFunc;
    Color mCachedColor;
    Color mClickedColor;
};

using ButtonUPtr = std::unique_ptr<Button>;
