#pragma once

#include <vector>
#include <memory>

class VisualLayer;
class TriMesh;

class RectangleNode;

template <typename T>
class Image;

class Scene
{
public:
    Scene() = default;

    void syncLayers(const std::vector<VisualLayer*>& layers);

    void update(Image<unsigned char>* image = nullptr);

    unsigned getNumMeshes() const;

    TriMesh* getMesh(std::size_t idx) const;

private:

    void processRectangleNode(RectangleNode* node);

    std::vector<TriMesh*> mWorkingMeshs;
    std::vector<VisualLayer*> mLayers;
};
