#pragma once

#include "DiscretePoint.h"

#include "AbstractVisualNode.h"
#include "Color.h"

#include <memory>
#include <string>

class Color;

class TextNode : public AbstractVisualNode
{
public:
    TextNode(const std::string& content, const DiscretePoint& loc);

    ~TextNode();

    static std::unique_ptr<TextNode> Create(const std::string& content, const DiscretePoint& loc);

    const Color& getFillColor() const;
    const Color& getStrokeColor() const;

    std::string getContent() const;
    std::string getFontLabel() const;
    void setContent(const std::string& content);
    void setFillColor(const Color& color);
    void setStrokeColor(const Color& color);

private:
    std::string mContent;
    std::string mFontLabel;
    Color mFillColor;
    Color mStrokeColor;
};

using TextNodetr = std::unique_ptr<TextNode>;
