#include "VisualLayer.h"

#include "GeometryNode.h"
#include "TextNode.h"

VisualLayer::VisualLayer()
    : mShape(),
      mText()
{

}

std::unique_ptr<VisualLayer> VisualLayer::Create()
{
    return std::make_unique<VisualLayer>();
}

bool VisualLayer::hasShapeNode() const
{
    return bool(mShape);
}

bool VisualLayer::hasTextNode() const
{
    return bool(mText);
}

GeometryNode* VisualLayer::getShapeNode() const
{
    return mShape.get();
}

TextNode* VisualLayer::getTextNode() const
{
    return mText.get();
}

void VisualLayer::setShapeNode(GeometryNodePtr shape)
{
    mShape = std::move(shape);
}

void VisualLayer::setTextNode(std::unique_ptr<TextNode> text)
{
    mText = std::move(text);
}
